# Python Examples

This folder will contain examples of basic concepts for both syntax and logic. Complex examples may be in sub-folders, while simple examples are usually in the top level folder.

## Additional Reading

Here are some links with lots of additional and more in-depth information on the tutorial topics.

* [Data Types](https://realpython.com/python-data-types/)
* [Global Variables](https://realpython.com/python-constants/) and [Scope](https://realpython.com/python-scope-legb-rule/)
* [Imports](https://realpython.com/python-import/)
* [Strings](https://realpython.com/python-strings/) and [String Methods](https://www.w3schools.com/python/python_ref_string.asp)
* [For](https://realpython.com/python-for-loop/) and [While](https://realpython.com/python-while-loop/) Loops
* [Conditionals](https://realpython.com/python-conditional-statements/)
* [Exception Handling](https://realpython.com/python-exceptions/)
* [Functions](https://realpython.com/defining-your-own-python-function/)
* [Recursion](https://realpython.com/python-recursion/)
* [Match Case](https://discuss.python.org/t/match-case-syntax/20270)
* [Mutable vs. Immutable](https://realpython.com/python-mutable-vs-immutable-types/)
* [DocStrings](https://realpython.com/documenting-python-code/)
* [Data Classes](https://www.dataquest.io/blog/how-to-use-python-data-classes/)
* [Classes](https://realpython.com/python-classes/)
* [Files and Input/Output](https://realpython.com/working-with-files-in-python/)
* [Using REST APIs](https://realpython.com/api-integration-in-python/)